#include <libgsloop_config.h>

#include <gsloop_types.h>
#include <gsloop_client.h>
#include <gsloop_con.h>


int gsloop_client_cb(rn_pollevent_t	*rn_event)
{
	struct gsloop		*gsloop = rn_event->client.data;
	struct gsloop_client	*client = gsloop_con_get_client(gsloop, rn_event->fd);
	struct gsloop_event	gsloop_event = {
		.fd		= rn_event->fd,
		.revents	= rn_event->revents,
	};
	int			err;

	err = client->cb((gsloop_t *)gsloop, (gsloop_client_t *)client, &gsloop_event, client->data);

	return err;
}


int gsloop_client_close(gsloop_t	*gsloop_anon,
			gsloop_client_t	*gsloop_client_anon)
{
	struct gsloop		*gsloop = (struct gsloop *)gsloop_anon;
	struct gsloop_client	*gsloop_client = (struct gsloop_client *)gsloop_client_anon;
	int			err;

	err = gsloop_client->close(gsloop, (union gsloop_con *)gsloop_client);

	return err;
}
